gtkmm: Gdk::PixbufAnimation Class Reference

gtkmm 3.12.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gdk::PixbufAnimation Class Reference

The gdk-pixbuf library provides a simple mechanism to load and represent animations. More...

`#include <gdkmm/pixbufanimation.h>`

Inheritance diagram for Gdk::PixbufAnimation:
[legend]

## Public Member Functions
virtual | ~PixbufAnimation ()
GdkPixbufAnimation* | gobj ()
| Provides access to the underlying C GObject. More...
const GdkPixbufAnimation* | gobj () const
| Provides access to the underlying C GObject. More...
GdkPixbufAnimation* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
int | get_width () const
| Queries the width of the bounding box of a pixbuf animation. More...
int | get_height () const
| Queries the height of the bounding box of a pixbuf animation. More...
bool | is_static_image () const
| If you load a file with new_from_file() and it turns out to be a plain, unanimated image, then this function will return `true`. More...
Glib::RefPtr< Pixbuf > | get_static_image ()
| If an animation is really just a plain image (has only one frame), this function returns that image. More...
Glib::RefPtr< PixbufAnimationIter > | get_iter (const GTimeVal* start_time)
| Get an iterator for displaying an animation. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr < PixbufAnimation > | create_from_file (const Glib::ustring& filename)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gdk::PixbufAnimation > | wrap (GdkPixbufAnimation* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

The gdk-pixbuf library provides a simple mechanism to load and represent animations.

An animation is conceptually a series of frames to be displayed over time. Each frame is the same size. The animation may not be represented as a series of frames internally; for example, it may be stored as a sprite and instructions for moving the sprite around a background. To display an animation you don't need to understand its representation, however; you just ask gdk-pixbuf what should be displayed at a given point in time.

## Constructor & Destructor Documentation

virtual Gdk::PixbufAnimation::~PixbufAnimation | ( | ) |  |
| virtual

## Member Function Documentation

static Glib::RefPtr<PixbufAnimation> Gdk::PixbufAnimation::create_from_file | ( | const Glib::ustring & | filename) |  |
| static

int Gdk::PixbufAnimation::get_height | ( | ) |  | const

Queries the height of the bounding box of a pixbuf animation.

Returns
  Height of the bounding box of the animation.

Glib::RefPtr<PixbufAnimationIter> Gdk::PixbufAnimation::get_iter | ( | const GTimeVal * | start_time) |  |

Get an iterator for displaying an animation.

The iterator provides the frames that should be displayed at a given time. It should be freed after use with Glib::object_unref().

start_time would normally come from Glib::get_current_time(), and marks the beginning of animation playback. After creating an iterator, you should immediately display the pixbuf returned by Gdk::PixbufAnimationIter::get_pixbuf(). Then, you should install a timeout (with Glib::timeout_add()) or by some other mechanism ensure that you'll update the image after Gdk::PixbufAnimationIter::get_delay_time() milliseconds. Each time the image is updated, you should reinstall the timeout with the new, possibly-changed delay time.

As a shortcut, if start_time is `0`, the result of Glib::get_current_time() will be used automatically.

To update the image (i.e. possibly change the result of Gdk::PixbufAnimationIter::get_pixbuf() to a new frame of the animation), call Gdk::PixbufAnimationIter::advance().

If you're using Gdk::PixbufLoader, in addition to updating the image after the delay time, you should also update it whenever you receive the area_updated signal and Gdk::PixbufAnimationIter::on_currently_loading_frame() returns `true`. In this case, the frame currently being fed into the loader has received new data, so needs to be refreshed. The delay time for a frame may also be modified after an area_updated signal, for example if the delay time for a frame is encoded in the data after the frame itself. So your timeout should be reinstalled after any area_updated signal.

A delay time of -1 is possible, indicating "infinite."

Parameters

  start_time | Time when the animation starts playing.

Returns
  An iterator to move over the animation.

Glib::RefPtr<Pixbuf> Gdk::PixbufAnimation::get_static_image | ( | ) |  |

If an animation is really just a plain image (has only one frame), this function returns that image.

If the animation is an animation, this function returns a reasonable thing to display as a static unanimated image, which might be the first frame, or something more sophisticated. If an animation hasn't loaded any frames yet, this function will return `0`.

Returns
  Unanimated image representing the animation.

static GType Gdk::PixbufAnimation::get_type | ( | ) |  |
| static

Get the GType for this class, for use with the underlying GObject type system.

int Gdk::PixbufAnimation::get_width | ( | ) |  | const

Queries the width of the bounding box of a pixbuf animation.

Returns
  Width of the bounding box of the animation.

GdkPixbufAnimation* Gdk::PixbufAnimation::gobj | ( | ) |  |
| inline

Provides access to the underlying C GObject.

const GdkPixbufAnimation* Gdk::PixbufAnimation::gobj | ( | ) |  | const
| inline

Provides access to the underlying C GObject.

GdkPixbufAnimation* Gdk::PixbufAnimation::gobj_copy | ( | ) |  |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gdk::PixbufAnimation::is_static_image | ( | ) |  | const

If you load a file with new_from_file() and it turns out to be a plain, unanimated image, then this function will return `true`.

Use get_static_image() to retrieve the image.

Returns
  `true` if the "animation" was really just an image.

## Friends And Related Function Documentation

Glib::RefPtr< Gdk::PixbufAnimation > wrap | ( | GdkPixbufAnimation * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.